!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!                    interUAB, interVAB, interUB, interVB
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!	SUBROUTINES PER PORTARE TRAMITE INTERPOLAZIONE LE MATRICI DELLE 
!	COMPONENI DELLA VELOCIT¿ DALLA GRIGLIA SFALSATA ALLA GRIGLIA DEGLI 
!	SCALARI.
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	SUBROUTINE interUAB(IM,JM,iTMAX,A2D1,UAB,H,recNUMSIM,DX,DY,
     1                    CbordoS)
!-----------------------------------------------------------------------------!
      DIMENSION   A2D1(IM,JM,iTMAX),A(IM,JM),
     !			UAB(IM,JM,iTMAX),H(IM,JM,iTMAX)
	DATA	    undef/9999.9/,terra/1./
      CHARACTER*3 recNUMsim
	LOGICAL*4 Cbordos
!-----------------------------------------------------------------------------!
	Dv=0.5*DX
	Dl=sqrt(DY**2+(0.5*DX)**2)
	Den6=4*Dv+2*Dl
	Den4=2*Dv+2*Dl
	Den3=2*Dv+Dl
	Den2=Dv+Dl
	
	Wl=Dv/Den6 ! weight for i 
	Wv=Dl/Den6 ! interior point

	Wl_ANG=Dv/Den2 ! weight for corner points
	Wv_ANG=Dl/Den2 ! equal because there is always a distant item after another

	Wl_N=Dv/Den4 ! pesi per il
	Wv_N=Dl/Den4 ! north edge

	Wl_S=Wl_N ! weight for the south edge
	Wv_S=Wv_N ! equal to the north because there are always two away and two nearby
 
	Wl_E=Dv/Den3 ! pesi per il
	Wv_E=Dl/Den3 ! east edge

	Wl_O=Wl_E ! weight for the west edge
	Wv_O=Wv_E ! equal to the east because there are always two away and one nearby
	
	!******
      
	DO it=1,iTMAX
	!interior points
	do j=2,JM-1
	do i=2,IM-1
	   UAB(i,j,it)=Wl*( A2D1(i,j-1,it)+A2D1(i,j+1,it) +
     1	              A2D1(i+1,j+1,it)+A2D1(i+1,j-1,it) )  +
     2              Wv*( A2D1(i,j,it)  +A2D1(i+1,j,it) )
	enddo 
	enddo
	!north edge
	do i=2,IM-1
	   UAB(i,JM,it)=Wl_N*( A2D1(i,JM-1,it)+A2D1(i+1,JM-1,it) ) +
     1               Wv_N*( A2D1(i,JM,it)  +A2D1(i+1,JM,it) )
	enddo 
	!east edge      
	do j=2,JM-1
	   UAB(IM,j,it)=Wl_E*( A2D1(IM,j-1,it)+A2D1(IM,j+1,it) ) +
     1               Wv_E*( A2D1(IM,j,it))
	enddo
	!south edge
	IF(CbordoS)THEN
	!write(10,*) '                                 bordo sud'
	do i=2,IM-1
	   UAB(i,1,it)=Wl_S*( A2D1(i,2,it)+A2D1(i+1,2,it) ) +
     1              Wv_S*( A2D1(i,1,it)  +A2D1(i+1,1,it) )
	enddo
	ELSE
	do i=2,IM-1
	   UAB(i,2,it)=UAB(i,3,it)
	   UAB(i,1,it)=UAB(i,2,it)
	enddo
	ENDIF
	!west edge
	do j=2,JM-1
	   UAB(1,j,it)=Wl_O*( A2D1(2,j+1,it)+A2D1(2,j-1,it) ) +
     1              Wv_O*( A2D1(2,j,it))
	enddo 
	!corner
	UAB(1,JM,it)=Wl_ANG*A2D1(2,JM-1,it) + Wv_ANG*A2D1(2,JM,it) ! alto a sx
	UAB(IM,JM,it)=Wl_ANG*A2D1(IM,JM-1,it) + Wv_ANG*A2D1(IM,JM,it) ! alto a dx
	UAB(IM,1,it)=Wl_ANG*A2D1(IM,2,it) + Wv_ANG*A2D1(IM,1,it) ! basso a dx
	UAB(1,1,it)=Wl_ANG*A2D1(2,2,it) + Wv_ANG*A2D1(2,1,it) ! basso a sx
	ENDDO !su it
	!******
      DO it=1,iTMAX
        do j=1,JM
         do i=1,IM
           IF(H(i,j,1).eq.terra)THEN
             UAB(i,j,it)=undef
           ENDIF               
          enddo
         enddo
	ENDDO
!*******************   scrittura del file UmI2D    ***************************!
	!write(10,*)
	!write(10,*)'Scrittura file Uim2d eseguita!'
	!do it=1,iTMAx
	!do j=1,JM
	!do i=1,IM
	!  A(i,j)=UAB(i,j,it)
	!  time=it*1.
	!enddo
	!enddo
	!call PRINTxy('UIm2D'//recNUmsim,time,A,IM,1,JM,1)
	!enddo
************************************************************************
	!write(10,*)'interpolazione su UAB eseguita'
	RETURN	
	END

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	SUBROUTINE interVAB(IM,JM,iTMAX,A2D1,VAB,H,recNUMsim,DX,DY,
     1                    CbordoS)
!-----------------------------------------------------------------------------!
      dimension   A2D1(IM,JM,iTMAX),A(IM,JM),
     !			VAB(IM,JM,iTMAX),H(IM,JM,iTMAX)
      CHARACTER*3 recNUMsim
	DATA	    undef/9999.9/,terra/1./
	logical*4 Cbordos
!-----------------------------------------------------------------------------!
	!distance calculation and checking of all points for VA
	Dv=0.5*DY
	Dl=sqrt(DX**2+(0.5*DY)**2)
	Den6=4*Dv+2*Dl
	Den4=2*Dv+2*Dl
	Den3=2*Dv+Dl
	Den2=Dv+Dl
	
	Wl=Dv/Den6 ! pesi per i 
	Wv=Dl/Den6 ! interior points

	Wl_ANG=Dv/Den2 !  weight for corner points
	Wv_ANG=Dl/Den2 !equal because there are always two away and one nearby

	Wl_N=Dv/Den3 ! pesi per il
	Wv_N=Dl/Den3 ! north edge

	Wl_S=Wl_N ! weight for the south edge
	Wv_S=Wv_N ! equal to the north beacause there are always two away one nearby

	Wl_E=Dv/Den4 ! pesi per il
	Wv_E=Dl/Den4 ! east edge

	Wl_O=Wl_E ! weight for the west edge
	Wv_O=Wv_E ! equal to the east because there are always two away and two nearby
	!******
      DO it=1,iTMAX
	!interior point
	do j=2,JM-1
	do i=2,IM-1
	   VAB(i,j,it)=Wl*( A2D1(i-1,j,it)+A2D1(i-1,j+1,it) +
     1	              A2D1(i+1,j+1,it)+A2D1(i+1,j,it) )  +
     2              Wv*( A2D1(i,j,it)  +A2D1(i,j+1,it) )
	enddo 
	enddo
	!north edge
	do i=2,IM-1
	   VAB(i,JM,it)=Wl_N*( A2D1(i-1,JM,it)+A2D1(i+1,JM,it) ) +
     1               Wv_N*( A2D1(i,JM,it) )
	enddo 
	!east edge       
	do j=2,JM-1
	   VAB(IM,j,it)=Wl_E*( A2D1(IM-1,j,it)+A2D1(IM-1,j+1,it) ) +
     1               Wv_E*( A2D1(IM,j,it)+ A2D1(IM,j+1,it) )
	enddo
	!south edge
	IF(CbordoS)THEN
	!write(10,*) '                                 bordo sud'
	do i=2,IM-1
	   VAB(i,1,it)=Wl_S*( A2D1(i-1,2,it)+A2D1(i+1,2,it) ) +
     1              Wv_S*( A2D1(i,2,it) )
	enddo 
	ELSE
	do i=2,IM-1
	   VAB(i,2,it)=VAB(i,3,it)
	   VAB(i,1,it)=VAB(i,2,it)
	enddo
	ENDIF
	!west edge
	do j=2,JM-1
	   VAB(1,j,it)=Wl_O*( A2D1(2,j+1,it)+A2D1(2,j,it) ) +
     1              Wv_O*( A2D1(1,j,it)+A2D1(1,j+1,it) )
	enddo 
	!corners
	VAB(1,JM,it)=Wl_ANG*A2D1(2,JM,it) + Wv_ANG*A2D1(1,JM,it) ! alto a sx
	VAB(IM,JM,it)=Wl_ANG*A2D1(IM-1,JM,it) + Wv_ANG*A2D1(IM,JM,it) ! alto a dx
	VAB(IM,1,it)=Wl_ANG*A2D1(IM-1,2,it) + Wv_ANG*A2D1(IM,2,it) ! basso a dx
	VAB(1,1,it)=Wl_ANG*A2D1(2,2,it) + Wv_ANG*A2D1(1,2,it) ! basso a sx
      ENDDO ! Su it              
	!******
      DO it=1,iTMAX
        do j=1,JM
         do i=1,IM
           IF(H(i,j,1).eq.terra)THEN
             VAB(i,j,it)=undef
           ENDIF               
          enddo
         enddo
	ENDDO

!***********************   scrittura del file VmI2D    ***********************!
	!write(10,*)'Scrittura file Vim2d eseguita!'
	!write(10,*)
	!do it=1,iTMAx
	!do j=1,JM
	!do i=1,IM
	!A(i,j)=VAB(i,j,it)
	!time=it*1.
	!enddo
	!enddo
	!call PRINTxy('VIm2D'//recNUmsim,time,A,IM,1,JM,1)
	!enddo
!*****************************************************************************!
	!write(10,*)'interpolazione su VAB eseguita'
	RETURN
	END
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	SUBROUTINE interUB(IM,JM,KE,iTMAX,A3D1,UB,H,recNUMSIM,DX,DY,
     1                    CbordoS,myPROF)
!-----------------------------------------------------------------------------!
      dimension   A3D1(IM,JM,KE,iTMAX),A(IM,JM,KE),
     !			UB(IM,JM,KE,iTMAX),H(IM,JM,iTMAX),myPROF(KE)
	DATA	undef/9999.9/,terra/1./
      CHARACTER*3 recNUMsim
	logical*4 Cbordos
!-----------------------------------------------------------------------------!
	Dv=0.5*DX
	Dl=sqrt(DY**2+(0.5*DX)**2)
	Den6=4*Dv+2*Dl
	Den4=2*Dv+2*Dl
	Den3=2*Dv+Dl
	Den2=Dv+Dl
	
	Wl=Dv/Den6 ! pesi per i 
	Wv=Dl/Den6 ! interior points

	Wl_ANG=Dv/Den2 !  weight for corner points
	Wv_ANG=Dl/Den2 ! equal because there is always a distant item after another

	Wl_N=Dv/Den4 ! pesi per il
	Wv_N=Dl/Den4 ! north edge

	Wl_S=Wl_N ! weight for the south edge
	Wv_S=Wv_N ! equal to the north because there are always two away and two nearby
 
	Wl_E=Dv/Den3 ! pesi per il
	Wv_E=Dl/Den3 ! east edge

	Wl_O=Wl_E ! weight for the west edge
	Wv_O=Wv_E ! equal to the east beacause there are always two away and one nearby
	!******
      DO it=1,iTMAX
	DO k=1,KE
	!interior point
	do j=2,JM-1
	do i=2,IM-1
	   UB(i,j,k,it)=Wl*( A3D1(i,j-1,k,it)+A3D1(i,j+1,k,it) +
     1	              A3D1(i+1,j+1,k,it)+A3D1(i+1,j-1,k,it) )  +
     2              Wv*( A3D1(i,j,k,it)  +A3D1(i+1,j,k,it) )
	enddo 
	enddo
	!north edge
	do i=2,IM-1
	   UB(i,JM,k,it)=Wl_N*( A3D1(i,JM-1,k,it)+A3D1(i+1,JM-1,k,it) ) +
     1               Wv_N*( A3D1(i,JM,k,it)  +A3D1(i+1,JM,k,it) )
	enddo 
	!east edge       
	do j=2,JM-1
	   UB(IM,j,k,it)=Wl_E*( A3D1(IM,j-1,k,it)+A3D1(IM,j+1,k,it) ) +
     1               Wv_E*( A3D1(IM,j,k,it))
	enddo
	!south edge
	IF(CbordoS)THEN
	!write(10,*) '                                 bordo sud'
	do i=2,IM-1
	   UB(i,1,k,it)=Wl_S*( A3D1(i,2,k,it)+A3D1(i+1,2,k,it) ) +
     1                Wv_S*( A3D1(i,1,k,it)  +A3D1(i+1,1,k,it) )
	enddo
	ELSE
	do i=2,IM-1
	   UB(i,2,k,it)=UB(i,3,k,it)
	   UB(i,1,k,it)=UB(i,2,k,it)
	enddo
	ENDIF
	!west edge
	do j=2,JM-1
	   UB(1,j,k,it)=Wl_O*( A3D1(2,j+1,k,it)+A3D1(2,j-1,k,it) ) +
     1                Wv_O*( A3D1(2,j,k,it))
	enddo 
	!corners
	UB(1,JM,k,it)=Wl_ANG*A3D1(2,JM-1,k,it) + Wv_ANG*A3D1(2,JM,k,it) !alto a sx
	UB(IM,JM,k,it)=Wl_ANG*A3D1(IM,JM-1,k,it) + Wv_ANG*A3D1(IM,JM,k,it)!alto dx
	UB(IM,1,k,it)=Wl_ANG*A3D1(IM,2,k,it) + Wv_ANG*A3D1(IM,1,k,it) ! basso a dx
	UB(1,1,k,it)=Wl_ANG*A3D1(2,2,k,it) + Wv_ANG*A3D1(2,1,k,it) ! basso a sx
	
	ENDDO !su k
	ENDDO !su it
	!******
      DO it=1,iTMAX
	DO k=1,KE
        do j=1,JM
         do i=1,IM
           IF(H(i,j,1).eq.terra.or.myPROF(k).le.-H(i,j,1))THEN
	     ! IF(H(i,j,1).eq.terra)THEN
		   UB(i,j,k,it)=undef
	     ENDIF               
          enddo
         enddo
	ENDDO
	ENDDO
!*******************   scrittura del file UmI2D    ***************************!
	!write(10,*)
	!write(10,*)'Scrittura file Uim2d eseguita!'
	!DO it=1,iTMAx
	!DO k=1,KE
	!do j=1,JM
	!do i=1,IM
	!  A(i,j,k)=UB(i,j,k,it)
	!  time=it*1.
	!enddo
	!enddo
	!ENDDO
	!call PRINTxyz('UIm3D'//recNUmsim,time,iINT,A,IM,1,JM,1,KE)
	!ENDDO

	!DO it=1,iTMAx
	!DO k=1,KE
	!do j=1,JM
	!do i=1,IM
	!  A(i,j,k)=A3D1(i,j,k,it)
	!  time=it*1.
	!enddo
	!enddo
	!ENDDO
	!call PRINTxyz('A3D1_'//recNUmsim,time,iINT,A,IM,1,JM,1,KE)
	!ENDDO

!*****************************************************************************!
	!write(10,*)'interpolazione su UB eseguita'
	RETURN	
	END

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	SUBROUTINE interVB(IM,JM,KE,iTMAX,A3D1,VB,H,recNUMsim,DX,DY,
     1                    CbordoS,myPROF)
!-----------------------------------------------------------------------------!
      dimension   A3D1(IM,JM,KE,iTMAX),A(IM,JM,KE),
     !			VB(IM,JM,KE,iTMAX),H(IM,JM,iTMAX),myPROF(KE)
      CHARACTER*3 recNUMsim
	DATA	    undef/9999.9/,terra/1./
	logical*4 Cbordos
!-----------------------------------------------------------------------------!
	!distance calculation and checking of all points for VA
	Dv=0.5*DY
	Dl=sqrt(DX**2+(0.5*DY)**2)
	Den6=4*Dv+2*Dl
	Den4=2*Dv+2*Dl
	Den3=2*Dv+Dl
	Den2=Dv+Dl
	
	Wl=Dv/Den6 ! pesi per i 
	Wv=Dl/Den6 ! interior points

	Wl_ANG=Dv/Den2 !  weight for corner points
	Wv_ANG=Dl/Den2 ! equal because there is always a distant item after another

	Wl_N=Dv/Den3 ! pesi per il
	Wv_N=Dl/Den3 ! north edge

	Wl_S=Wl_N ! weight for the south edge
	Wv_S=Wv_N ! equal to the north because there are always two away and one nearby

	Wl_E=Dv/Den4 ! pesi per il
	Wv_E=Dl/Den4 ! east edge

	Wl_O=Wl_E ! weight for the west edge
	Wv_O=Wv_E ! equal to the east because there are always two away and two nearby
	!******
      DO it=1,iTMAX
	DO k=1,KE
	!interior point
	do j=2,JM-1
	do i=2,IM-1
	   VB(i,j,k,it)=Wl*( A3D1(i-1,j,k,it)+A3D1(i-1,j+1,k,it) +
     1	              A3D1(i+1,j+1,k,it)+A3D1(i+1,j,k,it) )  +
     2              Wv*( A3D1(i,j,k,it)  +A3D1(i,j+1,k,it) )
	enddo 
	enddo
	!north edge
	do i=2,IM-1
	   VB(i,JM,k,it)=Wl_N*( A3D1(i-1,JM,k,it)+A3D1(i+1,JM,k,it) ) +
     1               Wv_N*( A3D1(i,JM,k,it) )
	enddo 
	!east edge       
	do j=2,JM-1
	   VB(IM,j,k,it)=Wl_E*( A3D1(IM-1,j,k,it)+A3D1(IM-1,j+1,k,it) ) +
     1               Wv_E*( A3D1(IM,j,k,it)+ A3D1(IM,j+1,k,it) )
	enddo
	!south edge
	IF(CbordoS)THEN
	!write(10,*) '                                 bordo sud'
	do i=2,IM-1
	   VB(i,1,k,it)=Wl_S*( A3D1(i-1,2,k,it)+A3D1(i+1,2,k,it) ) +
     1              Wv_S*( A3D1(i,2,k,it) )
	enddo 
	ELSE
	do i=2,IM-1
	   VB(i,2,k,it)=VB(i,3,k,it)
	   VB(i,1,k,it)=VB(i,2,k,it)
	enddo
	ENDIF
	!west edge
	do j=2,JM-1
	   VB(1,j,k,it)=Wl_O*( A3D1(2,j+1,k,it)+A3D1(2,j,k,it) ) +
     1              Wv_O*( A3D1(1,j,k,it)+A3D1(1,j+1,k,it) )
	enddo 
	!corners
	VB(1,JM,k,it)=Wl_ANG*A3D1(2,JM,k,it) + Wv_ANG*A3D1(1,JM,k,it) ! alto a sx
	VB(IM,JM,k,it)=Wl_ANG*A3D1(IM-1,JM,k,it) + Wv_ANG*A3D1(IM,JM,k,it) ! alto a dx
	VB(IM,1,k,it)=Wl_ANG*A3D1(IM-1,2,k,it) + Wv_ANG*A3D1(IM,2,k,it) ! basso a dx
	VB(1,1,k,it)=Wl_ANG*A3D1(2,2,k,it) + Wv_ANG*A3D1(1,2,k,it) ! basso a sx
      
	ENDDO !on k
	ENDDO !on it              
	!******
      DO it=1,iTMAX
	DO k=1,KE
        do j=1,JM
         do i=1,IM
           IF(H(i,j,1).eq.terra.or.myPROF(k).le.-H(i,j,1))THEN
           !IF(H(i,j,1).eq.terra)THEN
		   VB(i,j,k,it)=undef
           ENDIF               
          enddo
         enddo
	ENDDO
	ENDDO
!*************************   scrittura del file VmI2D    *********************!
	!write(10,*)'Scrittura file Vim2d eseguita!'
	!write(10,*)
	!DO it=1,iTMAx
	!DO k=1,KE
	!do j=1,JM
	!do i=1,IM
	!A(i,j,k)=VB(i,j,k,it)
	!time=it*1.
	!enddo
	!enddo
	!ENDDO
	!call PRINTxyz('VIm3D'//recNUmsim,time,iINT,A,IM,1,JM,1,KE)
	!ENDDO
!*****************************************************************************!
	!write(10,*)'interpolazione su VB eseguita'
	RETURN
	END
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*