!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!~~~~~                 condizioni ai bordi aperti                        ~~~~~! 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE BCOND(IDX) 
!-----------------------------------------------------------------------------! 
      INCLUDE 'comblk98_lamp.fi'    
!-----------------------------------------------------------------------------! 
 
!###### Calculation of periodic forcing for East Flather Condition #####! 
 

!-----Realistic forcing data in Sestri (1978-79)
      if(mod(IINT,IORA).eq.0)then
       iserie=IINT/IORA
       do j=1,JM
        UAe(j)=serieUAe(iserie)
       enddo
      endif

!---------- Element 
      ELe(1)=0. 
       do j=2,JM 
        ELe(j)=ELe(j-1)-COR(1,j)*UAe(j)/GRAV*DY(1,j-1) 
       enddo 
      ELeJmid=ELe(JMM1/2) 
      do j=2,JMM1 
       ELe(j)=(ELe(j)-ELeJmid)*FSM(IM,j) 
      enddo 
      ELe(1)=ELe(2) 
      ELe(JM)=ELe(JMM1) 
 
!################################## 
 
      GO TO (10,20,30,40,50,60,70), IDX 
 
!################################ ELEVATION ################################### 
10    CONTINUE 
      do j=1,JM 
!-----------------------------   EAST   ---------------------------------------
      i=IM 
 

 
!>>>>>Zero Gradient 
       ELF(IM,j)=ELF(IMM1,j) 
 

 

!-----------------------------   WEST   --------------------------------------- 
      i=1 
 

 
!>>>>>Zero Gradient 
       ELF(1,j)=ELF(2,j) 
 

 
      enddo 
 
      do i=1,IM 
!-----------------------------   NORTH   -------------------------------------- 
      j=JM 
 

!-----------------------------   SOUTH   -------------------------------------- 
      j=1 
 

 
!>>>>>Zero Gradient 
       ELF(i,1)=ELF(i,2) 
 

 
      enddo 
 
!!!!!!Mask 
 
      DO j=1,JM 
       DO i=1,IM 
        ELF(i,j)=ELF(i,j)*FSM(i,j) 
       ENDDO 
      ENDDO 
 
      RETURN 
 
!############################ MEAN VELOCITY ################################### 
20    CONTINUE 
	 
      do j=1,JM 
!-----------------------------   EAST   --------------------------------------- 
 
      i=IM 
 

!>>>>>Flather 
       UAF(IM,j)=UAe(j)+sqrt(GRAV/H(IMM1,j))*(EL(IMM1,j)-ELe(j)) 
 

 
!#### TANGENTIAL COMPONENT 
!>>>>>Clamped 
       VAF(IM,j)=0. 
 

!-----------------------------   WEST   --------------------------------------- 
 
      i=1 
 

 
!>>>>>Orlanski 
       CPHDTX1=SQRT(GRAV*H(2,J))*DTE/DX(2,J) 

       UAF(2,J)=(UAB(2,J)+CPHDTX1*(2.0*UA(3,J)-UAB(2,J))) 
     &         /(1.0+CPHDTX1) 
 
 

!>>>>>Orlanski 
       CPHDTX1=SQRT(GRAV*H(1,j))*DTE/DX(1,j) 

       VAF(1,j)=(VAB(1,j)+CPHDTX1*(2.0*VA(2,j)-VAB(1,j))) 
     &        /(1.0+CPHDTX1) 
 

      enddo 
 
      do i=1,IM 
!-----------------------------   NORTH   -------------------------------------- 
 
      j=JM 
 

 
!-----------------------------   SOUTH   -------------------------------------- 
 
      j=1 
 
!#####NORMAL COMPONENT 
!>>>>>Clamped 
      VAF(i,2)=0. 
 

 
!>>>>>Zero gradient 
      UAF(i,1)=UAF(i,2) 
 

      enddo 
 
!!!!!!Mask 
      DO j=1,JM 
       DO i=1,IM 
        UAF(i,j)=UAF(i,j)*DUM(i,j) 
        VAF(i,j)=VAF(i,j)*DVM(i,j) 
!cosmetic 
        VAF(i,1)=VAF(i,2) 
       ENDDO 
!cosmetic 
       UAF(1,j)=UAF(2,j) 
      ENDDO 
 
      RETURN 
 
!######################## INTERNAL VELOCITY ################################### 
30    CONTINUE 

 
      RETURN 
!####################### TEMP(UF) & SAL(VF) B.C.'S ############################ 
40    CONTINUE 
 
      RETURN 
!######################## VERTICAL VEL. B.C.'S ################################ 
50    CONTINUE 
     
      RETURN 
!######################## Q2(UF) & Q2L(VF) B.C.'S ############################# 
60    CONTINUE 
 
      RETURN 
 
!######################## WUSURF & WVSURF B.C.'S ############################## 
70    CONTINUE 

 
      RETURN 
!------------------------------------------------------------------------------ 
 
      END 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 
!*DECK MOLANSK 
!     Modified Orlanski 
!     from /ost/lyo/gom/nl/nl41k.f    ... l.oey  [11/24/95] 
 
      function molansk(veldtds,elb,el,elf) 
      CO=(ELB-ELF)/(ELF+ELB-2.*EL+1.E-18) + VELDTDS 
      if(CO.gt.0.0)then 
      molansk=1.0 
      else 
      molansk=0.0 
      endif 
      return 
      end 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 
!*DECK OLANSK 
!     Original Orlanski 
!     from nl41l.f    ... l.oey  [11/12/95] 
 
      function olansk(veldtds,elb,el,elf) 
      CO=(ELB-ELF)/(ELF+ELB-2.*EL+1.E-18) + VELDTDS 
      if(CO.ge.1.0)then 
      olansk=1.0 
      else 
      if(CO.gt.0.0)then 
      olansk=CO 
      else 
      olansk=0.0 
      endif 
      endif 
      return 
      end 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 
 
 
 









