!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!~~~~~        Specific simulation and initial conditions            ~~~~~! 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!02/02/2014=>VB:modifications
!31/01/2006=>AD: new sr for random numbers by Alain NOULLEZ
!16/05/2002=>AD: modification of masks assignment
!   2001   =>AD&MM first changes on the basis of bcond by pom98
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                          SOFTWARE LICENSING                  
!    This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License (GPL) as published 
! by the Free Software Foundation, either Version 2 of the license, or 
! (at your option) any later version.
!   This program is distributed  in the hope that  it  will be useful, but 
! without any warranty; without even the implied warranty of merchantabil-
! ity or fitness for a particular purpose. See  the GPL  for more details. 
!   A copy of the GNU General Public License is available at 
!                   http://www.gnu.org/copyleft/gpl.html   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
      SUBROUTINE ICOND(datadir,recNUMsim,NREAD,TSURF,SSURF,TCLIM,SCLIM)      
 
!-----------------------------------------------------------------------------! 
      INCLUDE 'comblk98_lamp.fi' 
      CHARACTER*3  recNREADsim 
 
      DIMENSION TSURF(IM,JM),SSURF(IM,JM), 
     &         TCLIM(IM,JM,KB),SCLIM(IM,JM,KB), 
     &         DRHOX(IM,JM,KB),DRHOY(IM,JM,KB),DRX2D(IM,JM),DRY2D(IM,JM) 
 
!-----------------------------------------------------------------------------! 
 
      INCLUDE 'params98_lamp.fi' 

	write(*,*) 'Start sr ICOND' 
!====================== grid preparation=================================! 
!->   Vertical grid
      CALL DEPTH(datadir,recNUMsim,6,Z,ZZ,DZ,DZZ,KB) !KL1=2 => Regular grid 
 
!->   Horizontal grid
      do j=1,JM 
       do i=1,IM 
        DX(i,j)=400. 
        DY(i,j)=200. 
       enddo 
      enddo  

!     Grid preparation
      open(18,file=datadir//'i_ics'//recNUMsim//'.txt') 
      i=1 
      X(i)=0. 
      write(18,'(I5,F12.5)') i,X(i)/1000. 
 
      open(19,file=datadir//'j_ipsilon'//recNUMsim//'.txt') 
      j=1 
      Y(j)=0. 
      write(19,'(I5,F12.5)') j, Y(j)/1000. 
 
      X(1)=0. 
      DO I=2,IM 
       X(I)=X(I-1)+DX(I-1,1) 
       write(18,'(I5,F12.5)') i,X(i)/1000. 
      ENDDO 
      Y(1)=0. 
      DO J=2,JM 
       Y(J)=Y(J-1)+DY(1,J-1) 
       write(19,'(I5,F12.5)') j, Y(j)/1000. 
      ENDDO 
      DO J=1,JM 
       DO I=1,IM 
        ART(I,J)=DX(I,J)*DY(I,J) 
       ENDDO 
      ENDDO 
      DO J=2,JM 
       DO I=2,IM 
        ARU(I,J)=.25*(DX(I,J)+DX(I-1,J))*(DY(I,J)+DY(I-1,J)) 
        ARV(I,J)=.25*(DX(I,J)+DX(I,J-1))*(DY(I,J)+DY(I,J-1)) 
       ENDDO 
      ENDDO 
      DO J=1,JM 
       ARU(1,J)=ARU(2,J) 
       ARV(1,J)=ARV(2,J) 
      ENDDO 
      DO I=1,IM 
       ARU(I,1)=ARU(I,2) 
       ARV(I,1)=ARV(I,2) 
      ENDDO 
 
      close(18) 
      close(19) 
 
!============ Bathymetry, masks, Coriolis parameters, and bottom roughness=========!  
!->   Value of land 
      terra=1. 
!->   Bathymetry 
! 
      !===READING BATHYMETRY

      open(21,file='../POM_DATA/INPUT/batimetria_corretta.dat', 
     &        status='old') 
 
      do ir=1,7 
        read(21,*) 
      enddo 
      do j=JM,1,-1 
        read(21,'(115(f10.4,10x))') (H(i,j), i=1,IM) 
      enddo 
      close(21) 
 

 
!FA&PO-CONTROLLO Zlamp more depth levels of the bathymetry
      do j=0,JMLAMP 
         do i=0,IMLAMP 
            if((-deltaZ*O).le.H(i+IOLAMP,j+JOLAMP))then 
               write(*,*)'' 
               write(*,*)'Controllo profondita` LAMP non rispettato' 
               write(*,*)' => STOP' 
               stop 
            endif 
         enddo 
       enddo 
       write(*,*)'' 
       write(*,*)'Controllo profondita` rispettato ' 
       write(*,*)' => OK' 
 
!     Masks preparation
      DO J=1,JM 
       DO I=1,IM 
        FSM(I,J)=1. 
        DUM(I,J)=1. 
        DVM(I,J)=1. 
        IF(H(I,J).eq.terra) FSM(I,J)=0. 
       ENDDO 
      ENDDO 
      DO J=2,JM 
       DO I=2,IM 
        DUM(I,J)=FSM(I,J)*FSM(I-1,J)                                 
        DVM(I,J)=FSM(I,J)*FSM(I,J-1)                                      
       ENDDO 
      ENDDO 
 
!->   Coriolis 
      do i=1,IM 
       do j=1,JM 
        COR(I,J)=1.03E-04 
       enddo 
      enddo 
 
!->   Roughness(CBC is used to calculate WUBOT and WVBOT) 
      do i=1,IM 
       do j=1,JM 
        CBC(i,j)=0.0025 

       enddo 
      enddo 
!====================== Initial conditions ==================================! 
!HOT START
!->   Reading date for Hot Start
!      February
      call READxy('ELB__219',ELB,IM,JM,10)
      call READxy('UAB__219',UAB,IM,JM,10)
      call READxy('VAB__219',VAB,IM,JM,10)


      !---READING DATA
      open(21,file='../POM_DATA/INPUT/inflow_n3408_08Feb79_30Jun79.txt')

      write(*,*) Nore
      do iserie=1,Nore 
      write(*,*) iserie
       read(21,'(F12.5)') serieUAe(iserie)
       write(*,*)'serieUAe=',serieUAe(iserie)
      enddo
      do j=1,JM
         UAe(j)=serieUAe(1)
      enddo
!->   Elevation
      ELe(1)=0.
      do j=2,JM
       ELe(j)=ELe(j-1)-COR(1,j)*UAe(j)/GRAV*DY(1,j-1)
      enddo
      ELeJmid=ELe(JMM1/2)
      do j=2,JMM1
       ELe(j)=(ELe(j)-ELeJmid)*FSM(IM,j)
      enddo
      ELe(1)=ELe(2)
      ELe(JM)=ELe(JMM1)
      do j=1,JM 
       do i=1,IM 
        EL(i,j)=ELB(i,j) 
        ETB(i,j)=ELB(i,j) 
        ET(i,j)=ELB(i,j) 
        D(I,J)=H(I,J)+EL(I,J) 
        DT(I,J)=H(I,J)+ET(I,J) 
       enddo 
      enddo 


 
!->    Horizontal viscosity and diffusivity
       do j=1,JM 
        do i=1,IM 
           AAM2D(I,J)=1. 
        enddo 
       enddo 


!=============================================================================! 
!    Pressure gradient baroclinic
      CALL BAROPG(DRHOX,DRHOY) 
      DO K=1,KBM1 
       DO J=1,JM 
        DO I=1,IM  
         DRX2D(I,J)=DRX2D(I,J)+DRHOX(I,J,K)*DZ(K) 
         DRY2D(I,J)=DRY2D(I,J)+DRHOY(I,J,K)*DZ(K) 
        ENDDO 
       ENDDO 
      ENDDO 
 

       do i=1,IM
        WUSURF(i,j)=0.
        WVSURF(i,j)=0.
       enddo 
      

 
************************************************************************ 
*                   INITIAL CONDITIONS FOR LAMP3D                * 
************************************************************************ 
 
       deltaX=DX(IOLAMP,JOLAMP) 
       deltaY=DY(IOLAMP,JOLAMP) 

! Pseudo random initialization extraction
      trash=ranx(seme)
*     Sigma 
       do j=1,JMLAMP 
        do i=1,IMLAMP 
         SIGMA(i,j)=3.46 
        enddo 
       enddo 
 
*     Initial concentration of particles
	do k=O,0 
	 do j=1,JMLAMP 
	  do i=1,IMLAMP 
             CONC(i,j,k)=0. 
	  enddo 
	 enddo 
	enddo 
 
 
        ISORGENTE=(IMLAMP/2) 
        JSORGENTE=(JMLAMP/2) 
        KSORGENTE=(-2) 
 
        intCONCZERO=0 
 
	CONC(ISORGENTE,JSORGENTE,KSORGENTE)=intCONCZERO 
 
!FA&PO-CONTROLLO ON THE NUMBER OF PARTICLES
        Npartnecessarie=(DAYS*24*3600/DTI+2)*iFLUXSORGENTE+intCONCZERO 
        if(Npartnecessarie.gt.Nparticelle) then 
           write(*,*)'' 
           write(*,*)'Insufficient memory allocated for the particles' 
           write(*,*)'Npartnecessarie=',Npartnecessarie 
           write(*,*)'Nparticelle    =',Nparticelle 
           stop 
        endif 

*-------------------------------------------------------------------- 
*     Counters removed particles
      Icmorte=0          
      Icfuori=0 
 
 
*---- Allocation of the symbolic initial position for all particles
      do Ip=1,Nparticelle 
        Xpart(Ip)=-999 
        Ypart(Ip)=-999 
        Zpart(Ip)=999 
      enddo 
*---- Allocation vector SURVPROB (chance of survival) 
      do Ip=1,Nparticelle            
        SURVPROB(Ip)=-9              
      enddo                          
*---- Assigning initial positions to the initial concentration 
 
      Icnate=0 
 
        do J=JMLAMP-1,1,-1 
        do I=1,IMLAMP-1 
        do K=0,O,-1 
            newNp=NINT(CONC(i,j,k))+Icnate 
            do Ip=Icnate+1,newNp 
              SURVPROB(Ip)=1 
              Icnate=Icnate+1 
              Xpart(Ip)=i*deltaX      
              Ypart(Ip)=j*deltaY 
              Zpart(Ip)=k*deltaZ 
 
            enddo 
            Icnate=newNp 
        enddo 
        enddo 
        enddo 
 
      write(*,*)'Icnate=',Icnate 

!-------------------------------------------------------- 

      write(*,*) 'Finish sr ICOND' 

      RETURN 
      END 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
